package lab5;

import c4e.phidget.HardwareInterface;
import java.util.Scanner;
import com.phidgets.*;

public class Calibrate extends HardwareInterface
{

	// ------------------------------------Attributes
	private Scanner input;
	private double servo0Position;
	private double servo1Position;
	private long timerDelay;

	// ------------------------------------Constructor
	public Calibrate(boolean debug)
	{
		super(debug);
		this.servo0Position = 0;
		this.servo1Position = 0;
		this.input = new Scanner(System.in);
		this.timerDelay = 1000;
		this.setTimer(this.timerDelay);
	}

	// ------------------------------------Timer
	@Override
	public void timerCallback()
	{
		AdvancedServoPhidget servo = this.getServoBoard();
		if (servo == null)
		{
			System.out.println("Waiting for servo to wake up ...");
			this.setTimer(this.timerDelay);
			return;
		}
		
		//------------------------------------------------Axis 0
		this.setServoEngageState(0, true);
		this.setServoEngageState(1, false);
		double max0 = this.getServoPositionMax(0);
		double min0 = this.getServoPositionMin(0);
		double nextPosition;

		System.out.println("Calibrating axis 0:");
		nextPosition = (max0 + min0) / 2;
		while (nextPosition > -1000)
		{
			this.servo0Position = nextPosition;
			this.setServoPosition(0, this.servo0Position);
			System.out.printf("Current position is %f [its range is %f to %f]\n", this.servo0Position, min0, max0);
			System.out.print("Enter new position (use -1000 to end) ... "); 
			nextPosition = input.nextDouble();
		} 
		
		//------------------------------------------------Axis 1
		this.setServoEngageState(0, false);
		this.setServoEngageState(1, true);
		double max1 = this.getServoPositionMax(1);
		double min1 = this.getServoPositionMin(1);

		System.out.println("Calibrating axis 1");
		nextPosition = (max1 + min1) / 2;
		while (nextPosition > -1000)
		{
			this.servo1Position = nextPosition;
			this.setServoPosition(1, this.servo1Position);
			System.out.printf("Current position is %f [its range is %f to %f]\n", this.servo1Position, min1, max1);
			System.out.print("Enter new position (use -1000 to end) ... "); 
			nextPosition = input.nextDouble();
		}

		//------------------------------------------------Done
		this.setServoEngageState(1, false);
		System.out.printf("Base positions are %f and %f\n",	this.servo0Position, this.servo1Position);
		System.exit(0);
	}
}
