package lab5;

import c4e.phidget.HardwareInterface;

import java.util.Scanner;

import com.phidgets.AdvancedServoPhidget;

public class Square extends HardwareInterface
{

	// ------------------------------------Attributes
	private static final double SERVO_0_POSITION = 115;
	private static final double SERVO_1_POSITION = 115;
	private static final double TRANSLATION_SPEED = -10; // speed needed for 20cm/s forward linear motion
	private static final double ROTATION_SPEED = -5.0; // speed needed for 22.5 deg/sec rotational motion clockwise

	private Scanner input;
	private long timerDelay;

	// ------------------------------------Constructor
	public Square(boolean debug)
	{
		super(debug);
		this.input = new Scanner(System.in);
		this.timerDelay = 1000;
		this.setTimer(this.timerDelay);
	}

	public void turnLeft()
	{
		System.out.printf("Robot turning 90 degrees left%n");
	}

	public void turnRight()
	{
		System.out.printf("Robot turning 90 degrees to the right%n");
	}

	public void moveForward(double distance)
	{
		System.out.printf("Robot moving forwards %f meters%n", distance);
	}

	// ------------------------------------Timer
	@Override
	public void timerCallback()
	{
		AdvancedServoPhidget servo = this.getServoBoard();
		if (servo == null)
		{
			System.out.println("Waiting for servo to wake up ...");
			this.setTimer(this.timerDelay);
			return;
		}

		this.setServoPosition(0, SERVO_0_POSITION);
		this.setServoPosition(1, SERVO_1_POSITION);
		this.setServoEngageState(0, true);
		this.setServoEngageState(1, true);

		// move in a square of size 1m
		moveForward(1.0);
		c4e.util.ToolBox.sleep(5 * 1000);
		turnLeft();
		c4e.util.ToolBox.sleep(5 * 1000);
		moveForward(1.0);
		c4e.util.ToolBox.sleep(5 * 1000);
		turnLeft();
		c4e.util.ToolBox.sleep(5 * 1000);
		moveForward(1.0);
		c4e.util.ToolBox.sleep(5 * 1000);
		turnLeft();
		c4e.util.ToolBox.sleep(5 * 1000);
		moveForward(1.0);
		c4e.util.ToolBox.sleep(5 * 1000);
		turnLeft();

		this.setServoPosition(0, SERVO_0_POSITION);
		this.setServoPosition(1, SERVO_1_POSITION);
		this.setServoEngageState(0, false);
		this.setServoEngageState(1, false);

		System.exit(0);

	}
}
